# Technical Guide

The configuration setting to control the keyboard layout, key previews, and feedback options are set within the [launcher configuration](/bluefletch-enterprise/product-guides/bluefletch-launcher/launcher3/technical-guide.md) file.

| Field              | Description                                                                                                                                                                                                                                    |
| ------------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| hapticFeedback     | **string** Determines what feedback the user will receive on the press of a key. Valid values are `"hapticClick"`, `"click"`, `"haptic"`, and `"none"`. Defaults to `"hapticClick"`.                                                           |
| bigButtonText      | **boolean** Determines if the default keyboard will be the big button layout. Valid values are `true` and `false`. Defaults to `false`.                                                                                                        |
| alphanumeric       | **boolean** Determines if the default keyboard will be the alphanumeric layout. Valid values are `true` and `false`. Defaults to `false`.                                                                                                      |
| allowToggle        | **boolean** If `true`, allows the keyboard layout to be switched between alphanumeric, big button, and standard ("Qwerty") via a button below the keyboard. Defaults to `false`.                                                               |
| toggleLoggedIn     | **boolean** If `true`, allows the keyboard layout to be switched between alphanumeric, big button, and standard ("Qwerty") only when a user is logged in; when the user logs out, keyboard returns to the defined layout. Defaults to `false`. |
| keyPreview         | **boolean** Determines if key previews will be displayed on key press. Valid values are `true` and `false`. Defaults to `false`.                                                                                                               |
| isKeyboardLockable | **boolean** Determines if the keyboard can be locked/hidden. Valid values are `true` and `false`. Defaults to `false`.  Introduced in 2.3.2.                                                                                                   |
| isCapsLocked       | **boolean** Determines if the keyboard caps lock is enabled by default. Valid values are `true` and `false`. Defaults to `false`.  Introduced in 2.3.2.                                                                                        |

**Example Keyboard Config**

```json
"keyboard": {
  "hapticFeedback": "hapticClick",
  "bigButtonText": false,
  "alphanumeric": true,
  "keyPreview": false,
  "allowToggle": true,
  "toggleLoggedIn": false
}
```

### Application Details <a href="#application-details" id="application-details"></a>

**Package:** com.bluefletch.keyboard

**Play Store:** com.bluefletch.ems.emm.keyboard

After installing the application, set as default keyboard.

Example via ADB

```json
adb shell ime set com.bluefletch.keyboard/.KeyboardInputMethodServices
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bluefletch.com/bluefletch-enterprise/product-guides/device-applications/keyboard/technical-guide.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
